unit winmine1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, StdCtrls, ExtCtrls, Menus,WinMines;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Game: TMenuItem;
    Help: TMenuItem;
    About: TMenuItem;
    NewGame: TMenuItem;
    N1: TMenuItem;
    Beginner: TMenuItem;
    Intermediary: TMenuItem;
    Expert: TMenuItem;
    N2: TMenuItem;
    ExitGame: TMenuItem;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    SpeedButton1: TSpeedButton;
    WinMine1: TWinMine;
    Timer1: TTimer;
    procedure SpeedButton1Click(Sender: TObject);
    procedure WinMine1MineCount(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure WinMine1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ExitGameClick(Sender: TObject);
    procedure BeginnerClick(Sender: TObject);
    procedure WinMine1NewGame(Sender: TObject);
    procedure IntermediaryClick(Sender: TObject);
    procedure ExpertClick(Sender: TObject);
    procedure Panel2Resize(Sender: TObject);
    procedure WinMine1Win(Sender: TObject);
    procedure WinMine1Lose(Sender: TObject);
    procedure WinMine1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure AboutClick(Sender: TObject);
  private
    { Dclarations prives }
    Time:longint;
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
 WinMine1.Restart;
end;

procedure TForm1.WinMine1MineCount(Sender: TObject);
begin
 Label1.Caption:=IntToStr(WinMine1.Mines);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
 Time:=Time+1;
 Label2.Caption:=IntToStr(Time);
end;

procedure TForm1.WinMine1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if WinMine1.EndOfGame then exit;
 Timer1.Enabled:=True;
 SpeedButton1.Glyph.LoadFromResourceName(hInstance,'WINMINE2');
end;

procedure TForm1.ExitGameClick(Sender: TObject);
begin
 Application.Terminate;
end;

procedure TForm1.BeginnerClick(Sender: TObject);
begin
 WinMine1.NewGame(8,8,10);
end;

procedure TForm1.WinMine1NewGame(Sender: TObject);
begin
 SpeedButton1.Glyph.LoadFromResourceName(hInstance,'WINMINE1');
 Width:=WinMine1.Width+28;
 Height:=WinMine1.Height+105;
 Timer1.Enabled:=False;
 Time:=0;
 Label2.Caption:='0';
end;

procedure TForm1.IntermediaryClick(Sender: TObject);
begin
 WinMine1.NewGame(16,16,40);
end;

procedure TForm1.ExpertClick(Sender: TObject);
begin
 WinMine1.NewGame(30,16,99);
end;

procedure TForm1.Panel2Resize(Sender: TObject);
begin
 SpeedButton1.Left:=(Panel2.Width-SpeedButton1.Width) div 2;
end;

procedure TForm1.WinMine1Win(Sender: TObject);
begin
 Timer1.Enabled:=False;
 SpeedButton1.Glyph.LoadFromResourceName(hInstance,'WINMINE4');
end;

procedure TForm1.WinMine1Lose(Sender: TObject);
begin
 Timer1.Enabled:=False;
 SpeedButton1.Glyph.LoadFromResourceName(hInstance,'WINMINE3');
end;

procedure TForm1.WinMine1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if not WinMine1.EndOfGame then SpeedButton1.Glyph.LoadFromResourceName(hInstance,'WINMINE1');
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 Application.Icon:=Icon;
 WinMine1.Restart;
end;

procedure TForm1.AboutClick(Sender: TObject);
begin
 ShowMessage('FREE WinMine (C) 1999 by Paul TOTH'#13#10+
             '<tothpaul@mutimania.com>'#13#10+
             'http://www.multimania.com/tothpaul');
end;

end.
